using UnityEngine;
using UnityEngine.UIElements;

public class DynamicFontResize : MonoBehaviour {
    public float nearActorSize = 90;
    public float farActorSize = 120;
    public float nearTextSize = 70;
    public float farTextSize = 100;
    public float mindistance = 1;
    
    private WorldSpaceDialogueBox dialogueBox;
    private Camera _camera;
    private float currentDistance;
    private bool once;
    private Button[] buttons;

    
    public void Start() {
        _camera = Camera.main;
        dialogueBox = gameObject.GetComponent<WorldSpaceDialogueBox>();
        currentDistance = DistanceToCamera(transform.position);
        once = currentDistance > mindistance;
    }

    public void Update() {
        currentDistance = DistanceToCamera(transform.position);
        if(dialogueBox != null) {
            if(currentDistance > mindistance && once) {
                once = false;
                dialogueBox.SetActorFontSize(farActorSize);
                dialogueBox.SetTextFontSize(farTextSize);
            }

            if(currentDistance < mindistance && once == false) {
                once = true;
                dialogueBox.SetActorFontSize(nearActorSize);
                dialogueBox.SetTextFontSize(nearTextSize);
            }
        }
    }

    private float DistanceToCamera(Vector3 worldPosition) =>
        Vector3.Distance(_camera.transform.position, worldPosition);
}